open import Lib.Equality as Eq using (_==_; auto)
open import Lib.Word
open import Lib.Word-Tactics

open import Index

open import Step1.Theorem using (module TwoLevel-Less)
open TwoLevel-Less
open import Step2.Theorem using (module TwoLevel-Simplified ; f ; g)
open TwoLevel-Simplified

open import Step2.TwoLevel-Simplified-Lemmas
open import Step2.Lafont-S8

open Basis-Change group-like (Rewriting.step-cong TwoLevel-Simplified-Step.X-step)

module Step2.hypB.ax1 where

  lemma-[1] : ∀ {j : Index} -> TwoLevel-Simplified.Rel ⊢ (g *) (i j ^ 4) === (g *) ε

  lemma-[1] {₀} = axiom [S1]
  lemma-[1] {₁} = by-basis-change (X₀₁) (axiom [S1]) 10 auto
  lemma-[1] {₂} = by-basis-change (X₁₂ • X₀₁) (axiom [S1]) 10 auto
  lemma-[1] {₃} = by-basis-change (X₂₃ • X₁₂ • X₀₁) (axiom [S1]) 10 auto
  lemma-[1] {₄} = by-basis-change (X₃₄ • X₂₃ • X₁₂ • X₀₁) (axiom [S1]) 20 auto
  lemma-[1] {₅} = by-basis-change (X₄₅ • X₃₄ • X₂₃ • X₁₂ • X₀₁) (axiom [S1]) 20 auto
  lemma-[1] {₆} = by-basis-change (X₅₆ • X₄₅ • X₃₄ • X₂₃ • X₁₂ • X₀₁) (axiom [S1]) 20 auto
  lemma-[1] {₇} = by-basis-change (X₆₇ • X₅₆ • X₄₅ • X₃₄ • X₂₃ • X₁₂ • X₀₁) (axiom [S1]) 25 auto
