open import Lib.Equality as Eq using (_==_ ; auto)
open import Lib.Maybe
open import Lib.Boolean
open import Lib.Proposition
open import Lib.List
open import Lib.Word
open import Lib.Word-Lemmas
open import Lib.Word-Tactics

open Monoid-Equational
open Rewriting
open Associative
open InContext

open import Lib.MaybeEq
open import Lib.MaybeEq-Instances
open import CosetNF
open import Gate

open import Step7.Rel

module Step7.Basis-Change where

  lemma-Swap12-CCX2=CCX1-Swap12 : Rel ⊢ Swap12 • CCX2 === CCX1 • Swap12
  lemma-Swap12-CCX2=CCX1-Swap12 = axiom ax-Swap12-CCX2=CCX1-Swap12

  lemma-Swap12-CCX1=CCX2-Swap12 : Rel ⊢ Swap12 • CCX1 === CCX2 • Swap12
  lemma-Swap12-CCX1=CCX2-Swap12 = axiom ax-Swap12-CCX1=CCX2-Swap12 -- ListNF

  lemma-Swap12-CX01=CX02-Swap12 : Rel ⊢ Swap12 • CX01 === CX02 • Swap12
  lemma-Swap12-CX01=CX02-Swap12 = axiom ax-Swap12-CX01=CX02-Swap12 -- ListNF
  
  lemma-Swap12-CX02=CX01-Swap12 : Rel ⊢ Swap12 • CX02 === CX01 • Swap12
  lemma-Swap12-CX02=CX01-Swap12 = axiom ax-Swap12-CX02=CX01-Swap12 -- ListNF


  lemma-Swap12-CX10=CX20-Swap12 : Rel ⊢ Swap12 • CX10 === CX20 • Swap12
  lemma-Swap12-CX10=CX20-Swap12 = axiom ax-Swap12-CX10=CX20-Swap12 -- ListNF
  lemma-Swap12-CX20=CX10-Swap12 : Rel ⊢ Swap12 • CX20 === CX10 • Swap12
  lemma-Swap12-CX20=CX10-Swap12 = axiom ax-Swap12-CX20=CX10-Swap12 -- ListNF.listnfeq'
  lemma-Swap12-CCX0=CCX0-Swap12 : Rel ⊢ Swap12 • CCX0 === CCX0 • Swap12
  lemma-Swap12-CCX0=CCX0-Swap12 = axiom ax-Swap12-CCX0=CCX0-Swap12 -- ListNF.listnfeq'
  
  
  lemma-Swap12-X1=X2-Swap12 : Rel ⊢ Swap12 • X1 === X2 • Swap12
  lemma-Swap12-X1=X2-Swap12 = axiom ax-Swap12-X1=X2-Swap12 -- ListNF.listnfeq'


  lemma-Swap12-X2=X1-Swap12 : Rel ⊢ Swap12 • X2 === X1 • Swap12
  lemma-Swap12-X2=X1-Swap12 = axiom ax-Swap12-X2=X1-Swap12 -- ListNF.listnfeq'
  
  mvSwap12-step : Step-Function Gate Rel
  mvSwap12-step (Swap12-gen :: Swap12-gen :: xs) = Just (xs , at-head (axiom ax-Swap12-Swap12=ε))
  mvSwap12-step (Swap12-gen :: K0-gen :: xs) = Just (K0-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-K0=K0-Swap12))
  mvSwap12-step (Swap12-gen :: X0-gen :: xs) = Just (X0-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-X0=X0-Swap12))
  mvSwap12-step (Swap12-gen :: X1-gen :: xs) = Just (X2-gen :: Swap12-gen :: xs , at-head (lemma-Swap12-X1=X2-Swap12))
  mvSwap12-step (Swap12-gen :: X2-gen :: xs) = Just (X1-gen :: Swap12-gen :: xs , at-head (lemma-Swap12-X2=X1-Swap12))
  mvSwap12-step (Swap12-gen :: CCZ-gen :: xs) = Just (CCZ-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-CCZ=CCZ-Swap12))
  mvSwap12-step (Swap12-gen :: CCX0-gen :: xs) = Just (CCX0-gen :: Swap12-gen :: xs , at-head (lemma-Swap12-CCX0=CCX0-Swap12))
  mvSwap12-step (Swap12-gen :: CCX2-gen :: xs) = Just (CCX1-gen :: Swap12-gen :: xs , at-head lemma-Swap12-CCX2=CCX1-Swap12)
  mvSwap12-step (Swap12-gen :: CCX1-gen :: xs) = Just (CCX2-gen :: Swap12-gen :: xs , at-head lemma-Swap12-CCX1=CCX2-Swap12)
  mvSwap12-step (Swap12-gen :: CS01-gen :: xs) = Just (CS02-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-CS01=CS02-Swap12))
  mvSwap12-step (Swap12-gen :: CS12-gen :: xs) = Just (CS12-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-CS12=CS12-Swap12))
  mvSwap12-step (Swap12-gen :: CS02-gen :: xs) = Just (CS01-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-CS02=CS01-Swap12))
  mvSwap12-step (Swap12-gen :: S0-gen :: xs) = Just (S0-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-S0=S0-Swap12))
  mvSwap12-step (Swap12-gen :: S1-gen :: xs) = Just (S2-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-S1=S2-Swap12))
  mvSwap12-step (Swap12-gen :: S2-gen :: xs) = Just (S1-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-S2=S1-Swap12))
  mvSwap12-step (Swap12-gen :: iI-gen :: xs) = Just (iI-gen :: Swap12-gen :: xs , at-head (symm (axiom ax-iI-Swap12=Swap12-iI)))
  mvSwap12-step (Swap12-gen :: CX01-gen :: xs) = Just (CX02-gen :: Swap12-gen :: xs , at-head lemma-Swap12-CX01=CX02-Swap12)
  mvSwap12-step (Swap12-gen :: CX02-gen :: xs) = Just (CX01-gen :: Swap12-gen :: xs , at-head lemma-Swap12-CX02=CX01-Swap12)
  mvSwap12-step (Swap12-gen :: CX10-gen :: xs) = Just (CX20-gen :: Swap12-gen :: xs , at-head (lemma-Swap12-CX10=CX20-Swap12))
  mvSwap12-step (Swap12-gen :: CX20-gen :: xs) = Just (CX10-gen :: Swap12-gen :: xs , at-head (lemma-Swap12-CX20=CX10-Swap12))
  mvSwap12-step (Swap12-gen :: CX12-gen :: xs) = Just (CX21-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-CX12=CX21-Swap12))
  mvSwap12-step (Swap12-gen :: CX21-gen :: xs) = Just (CX12-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-CX21=CX12-Swap12))
  mvSwap12-step _ = Nothing

  module MvSwap12 = Rewriting.Step (step-cong mvSwap12-step)

  open Basis-Change2 mvSwap12-step public


  lemma-Swap01-CCX1=CCX0-Swap01 : Rel ⊢ Swap01 • CCX1 === CCX0 • Swap01
  lemma-Swap01-CCX1=CCX0-Swap01 =
    equational Swap01 • CCX1
      by right trans (symm right-unit) (symm (cong refl (axiom ax-Swap01-Swap01=ε)))
    equals Swap01 • CCX1 • Swap01 • Swap01
      by general-assoc auto
    equals Swap01 • (CCX1 • Swap01) • Swap01
      by right left symm (axiom ax-Swap01-CCX0=CCX1-Swap01)
    equals Swap01 • (Swap01 • CCX0) • Swap01
      by general-assoc auto
    equals (Swap01 • Swap01) • CCX0 • Swap01
      by trans (cong (axiom ax-Swap01-Swap01=ε) refl) left-unit
    equals CCX0 • Swap01

  lemma-Swap01-CCX0=CCX1-Swap01 : Rel ⊢ Swap01 • CCX0 === CCX1 • Swap01
  lemma-Swap01-CCX0=CCX1-Swap01 = axiom ax-Swap01-CCX0=CCX1-Swap01


  lemma-Swap01-CX20=CX21-Swap01 : Rel ⊢ Swap01 • CX20 === CX21 • Swap01
  lemma-Swap01-CX20=CX21-Swap01 = axiom ax-Swap01-CX20=CX21-Swap01 -- ListNF.listnfeq'

  lemma-Swap01-CCX2=CCX2-Swap01 : Rel ⊢ Swap01 • CCX2 === CCX2 • Swap01
  lemma-Swap01-CCX2=CCX2-Swap01 = axiom ax-Swap01-CCX2=CCX2-Swap01 -- ListNF.listnfeq'

  lemma-Swap01-CX12=CX02-Swap01 : Rel ⊢ Swap01 • CX12 === CX02 • Swap01
  lemma-Swap01-CX12=CX02-Swap01 = axiom ax-Swap01-CX12=CX02-Swap01 -- ListNF.listnfeq'
  lemma-Swap01-CX02=CX12-Swap01 : Rel ⊢ Swap01 • CX02 === CX12 • Swap01
  lemma-Swap01-CX02=CX12-Swap01 = axiom ax-Swap01-CX02=CX12-Swap01 -- ListNF.listnfeq'
  lemma-Swap01-CCX0=CCX0-Swap01 : Rel ⊢ Swap01 • CCX0 === CCX1 • Swap01
  lemma-Swap01-CCX0=CCX0-Swap01 = axiom ax-Swap01-CCX0=CCX1-Swap01 -- ListNF.listnfeq'
  
  lemma-Swap01-X0=X1-Swap01 : Rel ⊢ Swap01 • X0 === X1 • Swap01
  lemma-Swap01-X0=X1-Swap01 = axiom ax-Swap01-X0=X1-Swap01 -- ListNF.listnfeq'

  lemma-Swap01-X1=X0-Swap01 : Rel ⊢ Swap01 • X1 === X0 • Swap01
  lemma-Swap01-X1=X0-Swap01 = axiom ax-Swap01-X1=X0-Swap01
  
  lemma-Swap01-CX21=CX20-Swap01 : Rel ⊢ Swap01 • CX21 === CX20 • Swap01
  lemma-Swap01-CX21=CX20-Swap01 = axiom ax-Swap01-CX21=CX20-Swap01 -- ListNF.listnfeq'
  lemma-CX01-CX10-CX01=Swap01 : Rel ⊢ CX01 • CX10 • CX01 === Swap01
  lemma-CX01-CX10-CX01=Swap01 = symm (axiom ax-Swap01=CX01-CX10-CX01) -- ListNF.listnfeq'


  mvSwap01-step : Step-Function Gate Rel
  mvSwap01-step (Swap01-gen :: Swap01-gen :: xs) = Just (xs , at-head (axiom ax-Swap01-Swap01=ε))
  mvSwap01-step (Swap01-gen :: K0-gen :: Swap01-gen :: K0-gen :: xs) = Just (K0-gen :: Swap01-gen :: K0-gen :: Swap01-gen :: xs , at-head (axiom ax-Swap01-K0-Swap01-K0=K0-Swap01-K0-Swap01))
  mvSwap01-step (Swap01-gen :: X2-gen :: xs) = Just (X2-gen :: Swap01-gen :: xs , at-head (axiom ax-Swap01-X2=X2-Swap01))
  mvSwap01-step (Swap01-gen :: X0-gen :: xs) = Just (X1-gen :: Swap01-gen :: xs , at-head (lemma-Swap01-X0=X1-Swap01))
  mvSwap01-step (Swap01-gen :: X1-gen :: xs) = Just (X0-gen :: Swap01-gen :: xs , at-head (lemma-Swap01-X1=X0-Swap01))
  mvSwap01-step (Swap01-gen :: CCZ-gen :: xs) = Just (CCZ-gen :: Swap01-gen :: xs , at-head (axiom ax-Swap01-CCZ=CCZ-Swap01))
  mvSwap01-step (Swap01-gen :: CCX0-gen :: xs) = Just (CCX1-gen :: Swap01-gen :: xs , at-head (lemma-Swap01-CCX0=CCX1-Swap01))
  mvSwap01-step (Swap01-gen :: CCX1-gen :: xs) = Just (CCX0-gen :: Swap01-gen :: xs , at-head lemma-Swap01-CCX1=CCX0-Swap01)
  mvSwap01-step (Swap01-gen :: CCX2-gen :: xs) = Just (CCX2-gen :: Swap01-gen :: xs , at-head lemma-Swap01-CCX2=CCX2-Swap01)
  mvSwap01-step (Swap01-gen :: CS01-gen :: xs) = Just (CS01-gen :: Swap01-gen :: xs , at-head (axiom ax-Swap01-CS01=CS01-Swap01))
  mvSwap01-step (Swap01-gen :: CS02-gen :: xs) = Just (CS12-gen :: Swap01-gen :: xs , at-head (axiom ax-Swap01-CS02=CS12-Swap01))
  mvSwap01-step (Swap01-gen :: CS12-gen :: xs) = Just (CS02-gen :: Swap01-gen :: xs , at-head (axiom ax-Swap01-CS12=CS02-Swap01))
  mvSwap01-step (Swap01-gen :: S0-gen :: xs) = Just (S1-gen :: Swap01-gen :: xs , at-head (axiom ax-Swap01-S0=S1-Swap01))
  mvSwap01-step (Swap01-gen :: S1-gen :: xs) = Just (S0-gen :: Swap01-gen :: xs , at-head (axiom ax-Swap01-S1=S0-Swap01))
  mvSwap01-step (Swap01-gen :: S2-gen :: xs) = Just (S2-gen :: Swap01-gen :: xs , at-head (axiom ax-Swap01-S2=S2-Swap01))
  mvSwap01-step (Swap01-gen :: iI-gen :: xs) = Just (iI-gen :: Swap01-gen :: xs , at-head (symm (axiom ax-iI-Swap01=Swap01-iI)))
  mvSwap01-step (Swap01-gen :: CX10-gen :: xs) = Just (CX01-gen :: Swap01-gen :: xs , at-head (axiom ax-Swap01-CX10=CX01-Swap01))
  mvSwap01-step (Swap01-gen :: CX01-gen :: xs) = Just (CX10-gen :: Swap01-gen :: xs , at-head (axiom ax-Swap01-CX01=CX10-Swap01))
  mvSwap01-step (Swap01-gen :: CX12-gen :: xs) = Just (CX02-gen :: Swap01-gen :: xs , at-head (lemma-Swap01-CX12=CX02-Swap01))
  mvSwap01-step (Swap01-gen :: CX21-gen :: xs) = Just (CX20-gen :: Swap01-gen :: xs , at-head (lemma-Swap01-CX21=CX20-Swap01))
  mvSwap01-step (Swap01-gen :: CX02-gen :: xs) = Just (CX12-gen :: Swap01-gen :: xs , at-head (lemma-Swap01-CX02=CX12-Swap01))
  mvSwap01-step (Swap01-gen :: CX20-gen :: xs) = Just (CX21-gen :: Swap01-gen :: xs , at-head (lemma-Swap01-CX20=CX21-Swap01))
  mvSwap01-step _ = Nothing

  module MvSwap01 = Rewriting.Step (step-cong mvSwap01-step)

  module B01 =  Basis-Change2 mvSwap01-step

  swap012-step : Step-Function Gate Rel
  swap012-step (Swap12-gen :: Swap01-gen :: Swap12-gen :: xs) = Just (Swap01-gen :: Swap12-gen :: Swap01-gen :: xs , at-head (axiom ax-Swap12-Swap01-Swap12=Swap01-Swap12-Swap01))
  swap012-step _ = Nothing

  swap-step = mvSwap01-step then mvSwap12-step then swap012-step
  
  module MvSwap = Rewriting.Step (step-cong (swap-step))

  open MvSwap renaming (up-to-rewrite to up-to-swap) public
  
  module B02 =  Basis-Change2 (mvSwap01-step then mvSwap12-step then swap012-step)

  
